#!/bin/bash
# 211215 15.Dez.21 v0.10 Author jw@lxsbbs.eu, teamaster@mad-hatters-teatime.teanet.org
# Creative Commons Legal Code ShareAlike 1.0 https://creativecommons.org/   https://creativecommons.org/licenses/sa/1.0/legalcode
CERTCONF="../cert.conf.sh"; if [ -f "$CERTCONF" ]; then source "$CERTCONF"; else echo "config file not found...abort..."; exit 1; fi
if [ "$1" = "nodry" ] || [ "$2" = "nodry" ]; then nodry_flag="true"; fi
fname="tr.apache.vorlage.sh"

#set -x
function usage ()
{
    echo " "
    echo "${fname} {domain | vhost} [upddns]"
    echo " "
    exit
}
if [ "${1}" = "help" ] || [ -z "${1}" ]; then usage; exit; fi

if isdigit "$1"; then
    if ! f_find_cert_domain_vhost "$1"; then usage; fi
elif is_domainname "$1"; then
    if ! f_find_cert_domain "$1"; then usage; fi
else usage
fi
upddns_flag="false"
if [ "upddns" = "$2" ]; then upddns_flag="true"; fi


vnum="${ar_cert_domains[$maindex+$ar_cert_domains_col_vhost]}"
vdomain="${ar_cert_domains[$maindex+$ar_cert_domains_col_domain]}"
vdomainsed=${vdomain//./\\.} # wofuer? darum das mit sed verarbeitet wird?
valias="${ar_cert_domains[$maindex+$ar_cert_domains_col_alias]}"
vcert_le="${ar_cert_domains[$maindex+$ar_cert_domains_col_le]}"
vcert_self="${ar_cert_domains[$maindex+$ar_cert_domains_col_self]}"
#vcert="${ar_cert_domains[$maindex+$ar_cert_domains_col_vcert]}"
if [ -n "${ar_cert_domains[$maindex+$ar_cert_domains_col_vcert]}" ]; then
    vcert="${ar_cert_domains[$maindex+$ar_cert_domains_col_vcert]}"
else vcert="${ar_cert_domains[$maindex+$ar_cert_domains_col_domain]}"; fi

echo "vnum: $vnum; vdomain: $vdomain; vdomainsed: $vdomainsed"
echo "vcert: $vcert; valias: $valias"

vdir="$APACHE2DIR/vorlagen"
sedfile="$vdir/sedfile"
sedfile_80="$vdir/sedfile_80"
sedfile_ssl="$vdir/sedfile_ssl"

vorlage_gentoo_ssl_vhost_file="$vdir/99_vorlage.gentoo.domain.tld_ssl.conf"
vorlage_gentoo_vhost_file="$vdir/99_vorlage.gentoo.domain.tld.conf"
vorlage_gentoo_vhost_include_file="$vdir/99_vorlage.gentoo.domain.tld.include"

vorlage_debian_ssl_vhost_file="$vdir/99_vorlage.debian.domain.tld_ssl.conf"
vorlage_debian_vhost_file="$vdir/99_vorlage.debian.domain.tld.conf"
vorlage_debian_vhost_include_file="$vdir/99_vorlage.debian.domain.tld.include"

vorlage_sslcerts_file="$vdir/99_sslcerts.include"


destdir="$APACHE2DIR/${vnum}_${vdomain}"
rm -fr "${destdir}/"
mkdir -p ${destdir}
mkdir -p "${destdir}/debian"; mkdir -p "${destdir}/gentoo"
destdir_debian_80="${destdir}/debian/80"; mkdir -p "${destdir_debian_80}"
destdir_debian_ssl="${destdir}/debian/ssl"; mkdir -p "${destdir_debian_ssl}"
destdir_gentoo_80="${destdir}/gentoo/80"; mkdir -p "${destdir_gentoo_80}"
destdir_gentoo_ssl="${destdir}/gentoo/ssl"; mkdir -p "${destdir_gentoo_ssl}"
destdir_html="${destdir}/$vdomain" #; mkdir -p "${destdir_html}"

echo "s/VHDOMAIN/${vdomainsed}/g" > "$sedfile"
echo "s/VHALIAS/${valias}/g" >> "$sedfile"
echo "s/VHCERTS/${vnum}_sslcerts\.include/g" >> "$sedfile"


#if [ "${vcert_le}" = "le" ] || [ "${vcert_self}" = "self" ]; then
if [ "${vcert_le}" = "le" ] && [ "${vcert_self}" != "self" ]; then
echo "s/#__clxtlee__SSL/SSL/g" >> "$sedfile"
echo "s/#__clxtles__SSL/#SSL/g" >> "$sedfile"
echo "s/#__client__SSL/#SSL/g" >> "$sedfile"
elif [ "${vcert_le}" != "le" ] && [ "${vcert_self}" = "self" ]; then
echo "s/#__clxtlee__SSL/#SSL/g" >> "$sedfile"
echo "s/#__clxtles__SSL/SSL/g" >> "$sedfile"
echo "s/#__client__SSL/SSL/g" >> "$sedfile"
else
echo "s/#__clxtlee__SSL/#SSL/g" >> "$sedfile"
echo "s/#__clxtles__SSL/#SSL/g" >> "$sedfile"
echo "s/#__client__SSL/#SSL/g" >> "$sedfile"
fi
echo "s/__VCERTSELFDIR__/${SELFSIGNEDCERTDIR_sed}/g" >> "$sedfile"
echo "s/VCERT/${vcertca}/g" >> "$sedfile"
echo "s/CDOMAIN/${vcert}/g" >> "$sedfile"
#echo "s/#__reqlxs__Inc/#Inc/g" >> "$sedfile"


cat "$vdir/sedfile" > "$vdir/sedfile_80"
echo "s/VHINCLUDE/${vnum}_${vdomainsed}\.include/g" >> "$sedfile_80"
cat "$vdir/sedfile" > "$vdir/sedfile_ssl"
echo "s/VHINCLUDE/${vnum}_${vdomainsed}\.include/g" >> "$sedfile_ssl"

echo "s/#__reqlxs__Inc/#Inc/g" >> "$sedfile_80"
echo "s/#__forceSSL__Re/Re/g" >> "$sedfile_ssl"


sed -f "$sedfile_ssl" "$vorlage_sslcerts_file" > "${destdir}/${vnum}_sslcerts.include"

sed -f "$sedfile_80" "$vorlage_gentoo_vhost_file" > "${destdir_gentoo_80}/${vnum}_${vdomain}.conf"
sed -f "$sedfile_80" "$vorlage_gentoo_vhost_include_file" > "${destdir_gentoo_80}/${vnum}_${vdomain}.include"

sed -f "$sedfile_ssl" "$vorlage_gentoo_ssl_vhost_file" > "${destdir_gentoo_ssl}/${vnum}_${vdomain}_ssl.conf"
sed -f "$sedfile_ssl" "$vorlage_gentoo_vhost_file" > "${destdir_gentoo_ssl}/${vnum}_${vdomain}.conf"
sed -f "$sedfile_ssl" "$vorlage_gentoo_vhost_include_file" > "${destdir_gentoo_ssl}/${vnum}_${vdomain}.include"

sed -f "$sedfile_80" "$vorlage_debian_vhost_file" > "${destdir_debian_80}/${vnum}_${vdomain}.conf"
sed -f "$sedfile_80" "$vorlage_debian_vhost_include_file" > "${destdir_debian_80}/${vnum}_${vdomain}.include"

sed -f "$sedfile_ssl" "$vorlage_debian_ssl_vhost_file" > "${destdir_debian_ssl}/${vnum}_${vdomain}_ssl.conf"
sed -f "$sedfile_ssl" "$vorlage_debian_vhost_file" > "${destdir_debian_ssl}/${vnum}_${vdomain}.conf"
sed -f "$sedfile_ssl" "$vorlage_debian_vhost_include_file" > "${destdir_debian_ssl}/${vnum}_${vdomain}.include"


if [ "$upddns_flag" = "true" ]; then
    cp -afr "${vdir}/hthost/" "${destdir_html}/"
    cp -afr "${vdir}/upddns/" "${destdir_html}/html/upddns/"
else
    #echo "cp -afr ${vdir}/hthost/ ${destdir_html}/"
    cp -afr "${vdir}/hthost/" "${destdir_html}/"
fi

exit
