#!/bin/bash
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
if [ "$1" = "auto" ] || [ "$2" = "auto" ]; then auto_flag="true"; fi
if [ "$1" = "nodry" ] || [ "$2" = "nodry" ]; then nodry_flag="true"; lecmd="certbot renew"; else lecmd="certbot --dry-run renew"; fi
fname="certbot_renew.sh"

function usage_clean ()
{
    echo " "
    echo "${fname} <auto> <nodry>"
    echo " "
    echo "auto = without asking user (cron-mode)"
    echo " "
    echo "nodry = no --dry-run"
    echo " "
    echo "standard ist --dry-run"
    echo " "
    echo "zone = all; all zones from conf-file with dns01"
    echo "dns-server = all; all host from conf-file"
    echo " "
    echo "nameerver from domain array has priority"
    echo " "
    echo "renew all domains in /etc/letsencrypt/renewal"
    echo "check it with certtest_pem_enddate_leall.sh"
    echo " "
    exit
}

if [ "${1}" = "help" ]; then usage_clean; exit; fi
log_date=`date '+%y%m%d.%H%M%S'`
if [ "nodry_flag" = "nodry" ]; then log_file_le="$LOGDIR/cert.${log_date}.renew.log"
else log_file_le="$LOGDIR/cert.${log_date}.renew_dry-run.log"; fi

if [ "$auto_flag" = "true" ]; then
    #echo "do: ${lecmd} >> ${log_file_le} 2>&1"
    ${lecmd} >> ${log_file_le} 2>&1

    #echo "do: f_certbot_dns01_clean_hostdomains \"all\" \"${TRHOST}\" >> ${log_file_le} 2>&1"
    f_certbot_dns01_clean_hostdomains "all" "${TRHOST}" >> ${log_file_le} 2>&1
else
    echo ${lecmd}
    echo "execute ?"
    f_query "s"
    if is_query_ok; then
	#echo "do: ${lecmd} 2>&1 | tee ${log_file_le}"
	${lecmd} 2>&1 | tee ${log_file_le}
    fi

    echo; echo "delete _acme. TXT records ?"
    f_query "s"
    if is_query_ok; then
	#echo "do: f_certbot_dns01_clean_hostdomains \"all\" \"${TRHOST}\"  2>&1 | tee ${log_file_le}"
	f_certbot_dns01_clean_hostdomains "all" "${TRHOST}" 2>&1 | tee ${log_file_le}
    fi
fi
exit
