#!/bin/bash
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
if [ ! -d "$CERTDIR" ]; then echo "CERTDIR not found, pls config...abort..."; exit; fi
if [ "$1" = "auto" ] || [ "$2" = "auto" ]; then auto_flag="true"; fi
fname="certcopy.back.sh"


f_query_again="first" # all, first, none
f_query_again="all" # all, first, none
    for i in "${ar_cert_hosts[@]}"; do
	echo "---..."
	ihost="$i"
	rhost="${ihost}.${TRDOMAIN}"
	echo "rsync host: ${rhost}"; sleep 1
	if ! f_ping "$rhost"; then
#	    echo "host not avalable, skip..."; sleep 1; continue; fi
	    antwort=""
	    while true; do
		echo "host not avalable, s=skip; taste=try again"
		read antwort
		if [ "$antwort" = "s" ] || [ "$antwort" = "S" ]; then break; fi
		if [ "$antwort" = "a" ] || [ "$antwort" = "A" ]; then exit; fi
		if f_ping "$rhost"; then break; fi
	    done
	    if [ "$antwort" = "s" ] || [ "$antwort" = "S" ]; then continue; fi
	fi

	if [ ! -d "$CERTDIR/${ihost}" ]; then
		mkdir "$CERTDIR/${ihost}"; mkdir "$CERTDIR/${ihost}/archive"; mkdir "$CERTDIR/${ihost}/live"; mkdir "$CERTDIR/${ihost}/renewal"
	fi
	if [ ! -d "$CERTDIR/${ihost}" ] || [ ! -d "$CERTDIR/${ihost}/archive" ] || [ ! -d "$CERTDIR/${ihost}/live" ] || [ ! -d "$CERTDIR/${ihost}/renewal" ]; then
		echo "error dirs...abort..."; exit; fi

	if [ "$ihost" = "$TRHOST" ]; then
	    rsync_cmd_intern_flag="true"
	    rsync_cmd="rsync -avur "
	else
	    rsync_cmd_intern_flag="true"
	    rsync_cmd="rsync -avur -e \"ssh -i ${SSHLEKEY} \" root@${ihost}.${TRDOMAIN}:"
	fi
	anz_certs=0
	irow=0
	while [ "$irow" -lt "$ar_cert_domains_anz" ]; do
	    f_maindex "$irow" "0" "$ar_cert_domains_maxColumns"
	    icindex=$maindex

	    if [ "$ihost" != "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" ] \
	    || [ "le" != "${ar_cert_domains[$icindex+$ar_cert_domains_col_le]}" ]; then
		((irow++)); continue; fi
	    ((anz_certs++))
	    echo "---"
	    echo "ihost: $ihost;; ar_domain: ${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}; ar_host: ${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}"
	    echo

	    rsync_cmd1=""; rsync_cmd2=""; rsync_cmd3=""
	    rsync_cmd1+="$rsync_cmd"
	    rsync_cmd1+="/etc/letsencrypt/archive/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/"
	    rsync_cmd1+=" $CERTDIR/__host__/archive/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/"
	    if [[ "$rsync_cmd1" == *"__host__"* ]]; then rsync_cmd1=${rsync_cmd1//__host__/${ihost}}; fi

	    rsync_cmd2+="$rsync_cmd"
	    rsync_cmd2+="/etc/letsencrypt/live/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/"
	    rsync_cmd2+=" $CERTDIR/__host__/live/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/"
	    if [[ "$rsync_cmd2" == *"__host__"* ]]; then rsync_cmd2=${rsync_cmd2//__host__/${ihost}}; fi

	    if ((anz_certs == 1)); then
		rsync_cmd3+="$rsync_cmd"
		rsync_cmd3+="/etc/letsencrypt/renewal/"
		rsync_cmd3+=" $CERTDIR/__host__/renewal/"
		if [[ "$rsync_cmd3" == *"__host__"* ]]; then rsync_cmd3=${rsync_cmd3//__host__/${ihost}}; fi
	    fi

	    if [ "$auto_flag" = "true" ]; then s_query="y"
	    elif [ "$f_query_again" = "all" ] || ( [ "$f_query_again" = "first" ] && ((anz_certs==0)) ) ; then
		[ -n "${rsync_cmd1}" ] && echo "${rsync_cmd1}"
		[ -n "${rsync_cmd2}" ] && echo "${rsync_cmd2}"
		[ -n "${rsync_cmd3}" ] && echo "${rsync_cmd3}"
		echo; echo "execute ?"
		f_query "s"
		if [ "$s_query" = "auto" ]; then auto_flag="true"; s_query="y"; fi
	    else s_query="y"; fi
	
	    if is_query_skip; then
		if [ "$f_query_again" = "first" ]; then
		    break;
		else
		    ((irow++)); continue
		fi
	    elif is_query_ok; then
		if [ -n "${rsync_cmd1}" ]; then eval "${rsync_cmd1}"; err_ret1=$?; fi
		if [ -n "${rsync_cmd2}" ]; then eval "${rsync_cmd2}"; err_ret2=$?; fi
		if [ -n "${rsync_cmd3}" ]; then eval "${rsync_cmd3}"; err_ret3=$?; fi

		if ((err_ret1 != 0)) || ((err_ret2 != 0)) || ((err_ret3 != 0)); then
		    echo
		    echo "err_ret1: $err_ret1; err_ret2: $err_ret2; err_ret3: $err_ret3"
		    echo "ein fehler ist aufgetreten, taste=next host; c=continue; a=abort"
		    read s_query
		    if [ "$s_query" = "a" ] || [ "$s_query" = "A" ]; then echo "abort..."; exit
		    elif [ "$s_query" = "c" ] || [ "$s_query" = "C" ]; then echo "continue..."
		    elif [ "$s_query" = "auto" ]; then auto_flag="true"; s_query="y"
		    else echo "next host..."; break; fi
		fi
	    fi

	    ((irow++))
	done
    done
exit
