#!/bin/bash
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
dns_host="_acme-challenge"
fname="certhook_rfc2136.sh"

if [ -z "$CERTBOT_DOMAIN" ]; then echo "fail, \$CERTBOT_DOMAIN empty, abort..."; exit 1; fi
if [ -z "$CERTBOT_VALIDATION" ]; then echo "fail, \$CERTBOT_DOMAIN empty, abort..."; exit 1; fi

#dns_zone_hook="$CERTBOT_DOMAIN"; dns_server_hook="ns1.${CERTBOT_DOMAIN}"
dns_zone_hook="$CERTBOT_DOMAIN"; dns_server_hook=""
f_find_cert_domain_ns "$dns_zone_hook" dns_server_hook
#if ! is_domainname "$dns_server_hook"; then echo "$fname: dns_server not found or wrong name...abort..."; exit 1; fi
if ! is_nsname "$dns_server_hook"; then echo "$fname: dns_server not found or wrong name...abort..."; exit 1; fi

echo "fname: $fname,   dns_zone_hook: $dns_zone_hook"
echo "fname: $fname, dns_server_hook: $dns_server_hook"

echo "fname: $fname, CERTBOT_DOMAIN: ${CERTBOT_DOMAIN}"
echo "fname: $fname, CERTBOT_VALIDATION: ${CERTBOT_VALIDATION}"
echo "fname: $fname, Sending to DNS server..."

nsupdate << EOM
server ${dns_server_hook}
key ${dnstxtkey}
zone ${dns_zone_hook}
update add ${dns_host}.${CERTBOT_DOMAIN}. 360 TXT "${CERTBOT_VALIDATION}"
send
EOM

echo "fname: $fname, Wait 5 sec..."
sleep 5
echo "fname: $fname, rdy, return..."

exit
