#!/bin/bash
# 211215 15.Dez.21 v0.10 Author jw@bremnet.de, teamaster@mad-hatters-teatime.teanet.org
# Creative Commons Legal Code ShareAlike 1.0 https://creativecommons.org/   https://creativecommons.org/licenses/sa/1.0/legalcode
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
if [ "$1" = "nodry" ] || [ "$2" = "nodry" ]; then nodry_flag="true"; fi
fname="certonly_dns01.sh"

function usage ()
{
    echo " "
    echo "${fname} <domain> [nodry]"
    echo " "
    echo "domain.tld = cert for domain.tld & *.domain.tld (wildcard)"
    echo "(need entry in cert.conf.sh (ar_cert_domains))"
    echo " "
    echo "nodry = no --dry-run"
    echo " "
    exit
}
if [ "${1}" = "help" ] || [ -z "${1}" ]; then usage; exit; fi

if is_domainname "$1"; then
    dns_zone="$1"
elif is_domainname "$2"; then
    dns_zone="$2"; else echo "no domain found...abort..."; exit 1; fi
if ! f_find_cert_domain "$dns_zone" "$TRHOST"; then
    echo "dns_zone: $dns_zone; TRHOST: $TRHOST"
    echo "insert domain in config/domain_array first...abort..."
    exit 1
fi

log_date=`date '+%y%m%d.%H%M%S'`
log_file_le="$LOGDIR//cert.${log_date}.dns01.log"

#certhook="/root/le/certhook_rfc2136.sh"
certhook="${BINDIR}/certhook_rfc2136.sh"
dns_host="_acme-challenge"
f_find_cert_domain_ns "$dns_zone" dns_server

echo "cert4domains: -d "*.${dns_zone}" -d "${dns_zone}""
echo "domain: $dns_zone; nameserver: $dns_server"
echo "execute certbot ?"
f_query "s"

if is_query_ok; then
    if [ "$nodry_flag" = "true" ]; then
	certbot certonly --agree-tos --manual --preferred-challenge=dns --manual-auth-hook=${certhook} \
	--manual-public-ip-logging-ok -d "*.${dns_zone}" -d "${dns_zone}"  2>&1 | tee ${log_file_le}
    else
	certbot certonly --dry-run --agree-tos --manual --preferred-challenge=dns --manual-auth-hook=${certhook} \
	--manual-public-ip-logging-ok -d "*.${dns_zone}" -d "${dns_zone}"  2>&1 | tee ${log_file_le}
    fi
    echo
    f_certbot_dns01_clean_domain ${dns_zone}
fi

exit
