#!/bin/bash
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
fname="certbot_dns01_clean.sh"

log_date=`date '+%y%m%d.%H%M%S'`
log_file_le="$LOGDIR//cert.${log_date}.dns01.clean.log"

function usage_clean ()
{
    echo " "
    echo "${fname} <zone> [dns-server|host]"
    echo " "
    echo "zone = all; all zones from conf-file with dns01"
    echo "zone = <name>; zone (check ar_cert_domains)"
    echo "host = all; all host in ar_cert_hosts"
    echo "host = <name>; host (check ar_cert_hosts)"
    echo " "
    echo "when hostname not in ar_cert_hosts"
    echo "it will be an nameserver"
    echo "then: no check ar_cert_domains"
    echo " "
    echo "without parameters: all zones with dns01"
    echo "for this host ($TRHOST)"
    echo " "
    echo " "
    echo "${fname} "
    echo "${fname}  domain"
    echo "${fname}  domain   host"
    echo "${fname}  all      host"
    echo "${fname}  all      all"
    echo "${fname}  domain   nameserver"
    echo " "
    echo " "
    echo " "
    exit
}
    if [ "${1}" = "help" ]; then usage_clean; exit; fi
    echo
    is_dns_server_param="false"
    dns_host="_acme-challenge"

    is_dns_server_param="false"
    is_host_param="false"
    dns_zone=""
    dns_server=""
    host_param=""
    if [ -z "${1}" ]; then
#echo "deb:000"
	dns_zone="all"
	host_param="$TRHOST"
	is_host_param="true"
	echo "fname: $fname,   dns_zone: $dns_zone"
	[ -z "$host_param" ] && echo "fname: $fname, HOST: default" || echo "fname: $fname, host_param: $host_param"
    else
	dns_zone="$1"
	if [ -z "${2}" ]; then
#echo "deb:111"
	    echo "fname: $fname,   dns_zone: $dns_zone"
	    [ -z "$host_param" ] && echo "fname: $fname, HOST: default" || echo "fname: $fname, host_param: $host_param"
	elif [[ " ${ar_cert_hosts[@]} " =~ " ${2} " ]]; then
#echo "deb:222"
	    host_param="${2}"
	    is_host_param="true"
	    echo "fname: $fname,   dns_zone: $dns_zone"
	    [ -z "$host_param" ] && echo "fname: $fname, HOST: default" || echo "fname: $fname, host_param: $host_param"
	elif [ "all" = "$2" ]; then
#echo "deb:333"
	    host_param="all"
	    is_host_param="true"
	    echo "fname: $fname,   dns_zone: $dns_zone"
	    [ -z "$host_param" ] && echo "fname: $fname, HOST: default" || echo "fname: $fname, host_param: $host_param"
	else
#echo "deb:444"
	    dns_server="${2}"
	    echo "fname: $fname,   dns_zone: $dns_zone"
	    [ -z "$dns_server" ] && echo "fname: $fname, dns_server: default" || echo "fname: $fname, dns_server: $dns_server"
	    echo "extra without chek ar_cert_domains/cr_cert_hosts"
	    is_dns_server_param="true"
	fi
    fi

    is_host_param="true"
    echo; f_query "s"
    if is_query_ok; then
	if [ "$is_dns_server_param" = "true" ]; then
	    #echo "ro: f_certbot_dns01_clean_domain \"${dns_zone}\" \"${dns_server}\""
	    f_certbot_dns01_clean_domain "${dns_zone}" "${dns_server}"
	elif [ "$is_host_param" = "true" ]; then
	    #echo "ro: f_certbot_dns01_clean_hostdomains \"${dns_zone}\" \"${host_param}\""
	    f_certbot_dns01_clean_hostdomains "${dns_zone}" "${host_param}"
	else
	    #echo "ro: f_certbot_dns01_clean_hostdomains \"${dns_zone}\""
	    f_certbot_dns01_clean_hostdomains "${dns_zone}"
	fi
    fi

exit
