#!/bin/bash
# 211215 15.Dez.21 v0.10 Author jw@bremnet.de, teamaster@mad-hatters-teatime.teanet.org
# Creative Commons Legal Code ShareAlike 1.0 https://creativecommons.org/   https://creativecommons.org/licenses/sa/1.0/legalcode
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
if [ "$1" = "nodry" ] || [ "$2" = "nodry" ]; then nodry_flag="true"; fi
fname="certonly_dns01.sh"

function usage ()
{
    echo " "
    echo "${fname} <add|del> <domain> [nameserver]"
    echo " "
    echo "add = add _acme-challenge TXT Record"
    echo "del = del _acme-challenge TXT Record"
    echo " "
    echo "domain.tld = domain"
    echo "(need entry in cert.conf.sh (ar_cert_domains))"
    echo " "
    echo "namerserver = dns-server for domain "
    echo " "
    echo "nodry = no --dry-run"
    echo " "
    exit
}
if [ "${1}" = "help" ] || [ -z "${1}" ]; then usage; exit; fi

dns_zone=""; dns_server=""
add_flag="false"; del_flag="false"
if [ "add" = "$1" ]; then
    add_flag="true"
elif [ "del" = "$1" ]; then
    del_flag="true"
else
    echo "${fname} no add/del flag, abort..."; exit 1
fi

if is_domainname "$2"; then
    dns_zone="$2"; else echo "no domain found...abort..."; exit 1; fi
if ! f_find_cert_domain "$dns_zone"; then
    echo "domain not in array"
    echo "insert domain in config/domain_array first...abort..."; exit 1;
else
    if [ $# -ge 3 ] && [ -n "$3" ]; then
	dns_server="$3"
    else
	f_find_cert_domain_ns "$dns_zone" dns_server
    fi
fi

dns_host="_acme-challenge"
dns_validation="45in65b5v5v7bh7k0806565g24gv"

if ! is_domainname "$dns_zone"; then echo "no domain found...abort..."; exit 1; fi
if ! is_domainname "$dns_server" \
&& ! is_ipv4 "$dns_server" \
&& ! is_ipv6 "$dns_server"
then
    echo "$fname: dns_server not found or wrong name...abort..."; exit 1
fi

echo
echo "fname: $fname,   dns_zone: $dns_zone"
echo "fname: $fname, dns_server: $dns_server"

echo
if [ "$add_flag" = "true" ]; then
echo "create ${dns_host}... ${dns_validation}..."
echo "fname: $fname, Sending to DNS server..."
echo "key, or a=abort"
read antwort
if [ "$antwort" = "a" ] || [ "$antwort" = "A" ]; then echo "abort..."; exit 1; fi
#echo "key ${dnstxtkey}"
#echo "update add ${dns_host}.${dns_zone}. 360 TXT ${dns_validation}"
#exit

nsupdate << EOM
server ${dns_server}
key ${dnstxtkey}
zone ${dns_zone}
update add ${dns_host}.${dns_zone}. 360 TXT "${dns_validation}"
send
EOM
elif [ "$del_flag" = "true" ]; then
echo "delete ${dns_host}. ..."
echo "fname: $fname, Sending to DNS server..."

nsupdate << EOM
server ${dns_server}
key ${dnstxtkey}
zone ${dns_zone}
update del ${dns_host}.${dns_zone}. 360 TXT
send
EOM
fi
echo
echo "fname: $fname, Wait 5 sec..."
sleep 5
echo "fname: $fname, rdy, return..."


exit
