#!/bin/bash
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
if [ "$1" = "nodry" ] || [ "$2" = "nodry" ]; then nodry_flag="true"; fi
fname="certonly_webroot.sh"

function usage ()
{
    echo " "
    echo "${fname} <domain> [nodry]"
    echo " "
    echo "domain.tld = cert for domain.tld"
    echo "(need entry in cert.conf.sh)"
    echo " "
    echo "nodry = no --dry-run"
    echo " "
    echo "for wildcard certs run certonly_dns01.sh"
    echo " "
    exit
}

if [ "${1}" = "help" ]; then usage; exit; fi

if is_domainname "$1"; then
    webdomain="$1"
elif is_domainname "$2"; then
    webdomain="$2"
else
    echo "no domain found...abort..."; exit 1
fi

log_date=`date '+%y%m%d.%H%M%S'`
log_file_le="$LOGDIR//cert.${log_date}.renew.log"
log_file_le="$LOGDIR//cert.${log_date}.http.log"

echo "domain: $webdomain; webroot: /var/www/${webdomain}/html"
echo "execute certbot ?"
f_query "s"
if is_query_ok; then
	echo "do: ${lecmd} 2>&1 | tee ${log_file_le}"
	#${lecmd} 2>&1 | tee ${log_file_le}"
    if [ "$nodry_flag" = "true" ]; then
	certbot certonly --webroot -w /var/www/${webdomain}/html -d ${webdomain} 2>&1 | tee ${log_file_le}
    else
	certbot certonly --webroot --dry-run -w /var/www/${webdomain}/html -d ${webdomain} 2>&1 | tee ${log_file_le}
    fi
fi

exit
