#!/bin/bash
# 211215 15.Dez.21 v0.10 Author jw@bremnet.de, teamaster@mad-hatters-teatime.teanet.org
# Creative Commons Legal Code ShareAlike 1.0 https://creativecommons.org/   https://creativecommons.org/licenses/sa/1.0/legalcode
TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi
fname="certtest_pem_enddate_leall.sh"
function usage ()
{
    echo " "
    echo "${fname} [certdir] [host] [host]"  all
    echo " "
    echo "default certdir=$LEDIR (/etc/letsencrypt)"
    echo " "
    echo "all = all server "
    echo "renewal = this server for renewal "
    echo " "
    exit
}
all_param="false"
renewal_param="false"
renewal_flag="false"
ar_chosts=( )
chost=""; ar_chosts_anz=0
while [ $# -ge 1 ]; do
    if [ -d "$1" ]; then LEDIR="$1"
    elif [ "$1" = "help" ]; then usage
    elif [ "$1" = "all" ]; then all_param="true"
    elif [ "$1" = "renewal" ]; then renewal_param="true"
    else
	chost="$1"
	if ! [[ " ${ar_cert_hosts[@]} " =~ " ${chost} " ]]; then
	    chost="$1"
	    echo "$chost found, add"
	    ar_chosts[$ar_chosts_anz]="$chost"
	    ((ar_chosts_anz++))
	else
	    echo "$chost not found"
	fi
    fi
    shift
done

    f_read_le_domains
	echo "TRHOST: $TRHOST"
	for ar_cert_host in "${ar_cert_hosts[@]}"; do
	    if ((ar_chosts_anz > 0)); then
		if ! [[ " ${ar_chosts[@]} " =~ " ${ar_cert_host} " ]]; then
		    continue; fi
	    fi
	    irow=0
	    while [ "$irow" -lt "$ar_cert_domains_anz" ]; do
		renewal_flag="false"
		f_maindex "$irow" "0" "$ar_cert_domains_maxColumns"
		icindex=$maindex
		if [ "${ar_cert_domains[$icindex+$ar_cert_domains_col_le]}" != "le" ] \
		|| [ "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" != "$ar_cert_host" ]; then
		    ((irow++)); continue; fi

		s_renewal=""
		if [ -f "${LEDIR}/live/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/cert.pem" ]; then
		    if f_find_le_domain "${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}" ; then
			f_maindex "$ar_le_domains_row" "0" "$ar_le_domains_maxColumns"
			ar_le_domains[$maindex+$ar_le_domains_col_check]="check"
		    else echo "error21"
		    fi
		    stest=$(openssl x509 -enddate -noout -in ${LEDIR}/live/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}/cert.pem)
		    if [ "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" = "$TRHOST" ]; then
			if [ -f "${LEDIR}/renewal/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}.conf" ]; then
			    s_renewal="renewal"; renewal_flag="true"
			fi
		    else
			if [ -f "${LEDIR}/renewal/${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}.conf" ]; then
			    s_renewal="renewal (wrong host)"; renewal_flag="true"
			fi
		    fi
		else
		    if [ "${all_param}" = "false" ]; then
			if [ "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" != "$TRHOST" ]; then
			    ((irow++)); continue; fi
		    fi
		    stest="not found in LEDIR"
		    if [ "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" = "$TRHOST" ]; then
			s_renewal="renewal (not found in LEDIR)"; renewal_flag="true"
		    else
			s_renewal=""
		    fi
		fi
		if ([ "${renewal_param}" = "false" ]) \
		|| ([ "${renewal_param}" = "true" ] && [ "${renewal_flag}" = "true" ]) ; then
		    printf -v stest2 "%37s - %-33s - %-11s - %8s" "${ar_cert_domains[$icindex+$ar_cert_domains_col_domain]}" "$stest" "${ar_cert_domains[$icindex+$ar_cert_domains_col_host]}" "$s_renewal"
		    echo "${stest2}"
		fi

		((irow++))
	    done
	done
echo
#if false; then
    _row=0
    while [ "$_row" -lt "$ar_le_domains_anz" ]; do
	f_maindex "$_row" "0" "$ar_le_domains_maxColumns"
	if [ "${ar_le_domains[$maindex+$ar_le_domains_col_check]}" != "check" ]; then

		stest=$(openssl x509 -enddate -noout -in ${LEDIR}/live/${ar_le_domains[$maindex+$ar_le_domains_col_domain]}/cert.pem)
		printf -v stest2 "%37s - %-33s - %-11s - %8s" "${ar_le_domains[$maindex+$ar_le_domains_col_domain]}" "$stest" "" "not found in ar_cert_domains"
		echo "${stest2}"
	fi
	((_row++))
    done
#fi #if false; then

exit
