declare -i maindex=0
function f_maindex () { # multi array index
if [ $# -lt 3 ]; then echo "f_maindex: fehler parameter...abort..."; exit; fi
local _row=$1; local _col=$2; local _maxcol=$3
    maindex=$(($_row * $_maxcol + $_col))
}

is_query_ok () { if [ "$s_query" = "y" ]; then return $SUCCESS; else return $FAILURE; fi }
is_query_skip () { if [ "$s_query" = "s" ]; then return $SUCCESS; else return $FAILURE; fi }
s_query=""
function f_query () # parameter standard answer y,s,a
{
s_query=""
local _sstd="$1"
local _qtxt="y|yes = continue; a|abort = abort"
if [ "${_sstd}" = "y" ]; then _qtxt+="; other key = continue"; fi
if [ "${_sstd}" = "a" ]; then _qtxt+="; other key = abort"; fi
if [ "${_sstd}" = "s" ]; then _qtxt+="; other key = skip"; fi
    while true; do
	echo "${_qtxt}"
	read s_query; s_query=`echo "$s_query" | tr '[:upper:]' '[:lower:]'`
	if [ "$s_query" = "a" ] || [ "$s_query" = "abort" ]; then echo "abort..."; exit 1
	elif [ "$s_query" = "s" ] || [ "$s_query" = "skip" ]; then s_query="s"; echo "skip..."; break
	elif [ "$s_query" = "y" ] || [ "$s_query" = "yes" ]; then s_query="y"; echo "check..."; break
	else
	    if [ "$_sstd" = "a" ]; then s_query="s"; echo "abort..."; break; fi
	    if [ "$_sstd" = "s" ]; then s_query="s"; echo "skip..."; break; fi
	    if [ "$_sstd" = "y" ]; then s_query="y"; echo "check..."; break; fi
	fi
    done
return $SUCCESS
}

is_domainname ()
{
local _tested=""
    _tested=`echo $1 | grep -P '(?=^.{1,254}$)(^(?>(?!\d+\.)[a-zA-Z0-9_\-]{1,63}\.?)+(?:[a-zA-Z]{2,})$)'`
    if [ -n "$_tested" ]; then return $SUCCESS; else return $FAILURE; fi
}
is_nsname ()
{
local _name="$1"
    if is_domainname "${_name}" || is_ipv4 "${_name}" || is_ipv6 "${_name}"; then return $SUCCESS
    else return $FAILURE; fi
}
f_ping ()
{
    if ping -c 1 "$1" &> /dev/null
    then
	return $SUCCESS
    else
	return $FAILURE
    fi
}
isdigit ()
{
    [ $# -eq 1 ] || return $FAILURE
     
    case $1 in
      *[!0-9]*|"") return $FAILURE;;
    		*) return $SUCCESS;;
    esac
}
is_ipv4 ()
{
	if [ "$is_ip_nozero_flag" = "true" ] && [ "$1" = "0.0.0.0" ] ; then return $FAILURE; fi
	if [[ $1 =~ ^([0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$ ]]
	then
	    return $SUCCESS
	else
	    return $FAILURE
	fi
}
is_ipv6 ()
{
    if ([ "$is_ip_nozero_flag" = "true" ]) && ([ "$1" = "::0" ] || [ "$1" = "::" ]) ; then return $FAILURE; fi
	if [[ $1 =~ ^(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))$ ]]
	then
	    return $SUCCESS
	else
	    return $FAILURE
	fi
}
