TNCONF="/root/tn.conf.sh";
if [ -f "$TNCONF" ]; then source "$TNCONF"; elif [ -f "./tn.conf.sh" ]; then source "./tn.conf.sh"; elif [ -f "../tn.conf.sh" ]; then source "../tn.conf.sh"; else echo "config file not found...abort..."; exit 1; fi

# ssldir und s_caname anpassen/change
client_certs="first"  # "first", "all", "other"=no client certs
s_caname="DiscWorldSign"
if [ -n "$SELFSIGNEDCREATEDIR" ]; then ssldir="$SELFSIGNEDCREATEDIR"
else ssldir="/root/tn/selfca"; fi
if [ -n "$SELFSIGNEDCERTDIR" ]; then letsselfsigned_dir="$SELFSIGNEDCERTDIR"; letsselfsigned_copy="true"
else letsselfsigned_dir="/root/tn/letsselfsigned"; letsselfsigned_copy="true"; fi
#letsselfsigned_dir=""; letsselfsigned_copy="false"

ok_flag="false"
pwddir=`pwd`
echo  "ssldir: $ssldir; pwddir: $pwddir"
if [ "$ssldir" = "$pwddir" ]; then
    ok_flag="true"
else
    echo "need to adjust \"s_caname\" and \"ssldir\" in ownssl.conf.sh"
    echo "then switch to the directory and call it again."
    exit
fi
if [ "$letsselfsigned_copy" = "true" ]; then
    if [ ! -d "$letsselfsigned_dir/live" ]; then
	echo "letsselfsigned_dir: $letsselfsigned_dir not found"
	echo "need to adjust \"letsselfsigned_dir\" or \"letsselfsigned_copy\" in ownssl.conf.sh"
	echo "or create dir..."
	echo "create/erstellen? y=yes, a=abort"
	read antwort
	if [ "$antwort" = "y" ]; then
	    mkdir -p "$letsselfsigned_dir"
	    mkdir -p "$letsselfsigned_dir/live"
	elif [ "$antwort" = "a" ]; then
	    echo "abort..."; exit 1
	else
	    echo "letsselfsigned_dir: $letsselfsigned_dir not found"
	    echo "need to adjust \"letsselfsigned_dir\" or \"letsselfsigned_copy\" in ownssl.conf.sh"
	    echo "abort..."; exit 1
	fi
    fi
fi

function genconf_wildcard () {

local _domain="$1"

if [ -z "$1" ]; then echo "param domin missing"; exit;fi

cnfsrvfile="$ssldir/cnf.${s_domain}.srv"
cnfkeyfile="$ssldir/cnf.${s_domain}.key"

# cnf..key
echo "[req]" > "$cnfkeyfile"
echo "default_bits        = 4096" >> "$cnfkeyfile"
echo "default_keyfile = privkey.pem" >> "$cnfkeyfile"
echo "prompt = no" >> "$cnfkeyfile"
echo "default_md = sha256" >> "$cnfkeyfile"
echo "distinguished_name  = dn" >> "$cnfkeyfile"
echo "[dn]" >> "$cnfkeyfile"
echo "C=DE" >> "$cnfkeyfile"
echo "ST=NRW" >> "$cnfkeyfile"
echo "L=MeinOrt" >> "$cnfkeyfile"
echo "O=MeinName" >> "$cnfkeyfile"
echo "emailAddress            = webmaster@${s_domain}" >> "$cnfkeyfile"
echo "CN = ${s_domain}" >> "$cnfkeyfile"

echo "read with $cnfkeyfile"
#cat "$cnfkeyfile" > "$cnfsrvfile"

# cnf..srv
echo "authorityKeyIdentifier=keyid,issuer" >> "$cnfsrvfile"
echo "basicConstraints=CA:FALSE" >> "$cnfsrvfile"
echo "keyUsage = digitalSignature, nonRepudiation, keyEncipherment,dataEncipherment" >> "$cnfsrvfile"
echo "subjectAltName = @alt_names" >> "$cnfsrvfile"
echo "[alt_names]" >> "$cnfsrvfile"
echo "DNS.1    = ${s_domain}" >> "$cnfsrvfile"
echo "DNS.2    = *.${s_domain}" >> "$cnfsrvfile"


echo "read with $cnfkeyfile"

}
